﻿Public Class Form1
    Const DevId As Short = 0 ' デバイスIDを0とする
    Const LOG_BTN_START As String = "ログ開始" 'ログボタンの文字　停止中(開始可能状態)
    Const LOG_BTN_STOP As String = "ログ停止" 'ログボタンの文字　動作中(停止可能状態)
    Private PreCount(2) As Decimal 'ログ動作時の前回カウント値

    'コントロールの配列
    'この配列を通してコントロールを使用します。
    Private ArryTimerSel() As System.Windows.Forms.ComboBox
    Private ArryDividerSel() As System.Windows.Forms.ComboBox
    Private ArryEdgeUp() As System.Windows.Forms.RadioButton
    Private ArryEdgeDown() As System.Windows.Forms.RadioButton
    Private ArryLblFifolen() As System.Windows.Forms.Label
    Private ArryEtcMessage() As System.Windows.Forms.Label
    Private ArryLogBtn() As System.Windows.Forms.Button
    Private ArryListCnt() As System.Windows.Forms.ListBox
    Private ArryMeasTimer() As System.Windows.Forms.Timer

    '設定の初期化
    Private Sub SettingInit()
        Dim ch As Integer

        'コントロールの配列に画面のコントロールを設定します
        ArryTimerSel = New System.Windows.Forms.ComboBox() {TimerSel1, TimerSel2, TimerSel3}
        ArryDividerSel = New System.Windows.Forms.ComboBox() {DividerSel1, DividerSel2, DividerSel3}
        ArryEdgeUp = New System.Windows.Forms.RadioButton() {EdgeUp1, EdgeUp2, EdgeUp3}
        ArryEdgeDown = New System.Windows.Forms.RadioButton() {EdgeDown1, EdgeDown2, EdgeDown3}
        ArryLblFifolen = New System.Windows.Forms.Label() {LblFifolen1, LblFifolen2, LblFifolen3}
        ArryEtcMessage = New System.Windows.Forms.Label() {EtcMessage1, EtcMessage2, EtcMessage3}
        ArryLogBtn = New System.Windows.Forms.Button() {LogBtn1, LogBtn2, LogBtn3}
        ArryListCnt = New System.Windows.Forms.ListBox() {ListCnt1, ListCnt2, ListCnt3}
        ArryMeasTimer = New System.Windows.Forms.Timer() {MeasTimer1, MeasTimer2, MeasTimer3}

        For ch = 0 To 2
            '各コントロールのTagにchを設定して後で操作に使用します
            ArryTimerSel(ch).Tag = ch
            ArryDividerSel(ch).Tag = ch
            ArryEdgeUp(ch).Tag = ch
            ArryEdgeDown(ch).Tag = ch
            ArryLblFifolen(ch).Tag = ch
            ArryEtcMessage(ch).Tag = ch
            ArryLogBtn(ch).Tag = ch
            ArryListCnt(ch).Tag = ch
            ArryMeasTimer(ch).Tag = ch

            ArryEdgeUp(ch).Checked = True
            ArryTimerSel(ch).SelectedIndex = 0
            ArryDividerSel(ch).SelectedIndex = 0
            ArryListCnt(ch).Items.Clear()

            ArryLblFifolen(ch).BackColor = System.Drawing.Color.Transparent
        Next
    End Sub

    '各コントロールの表示状態を設定する
    Private Sub EnableDisableControl(ByVal ch As Byte, ByRef State As Boolean)
        If State = True Then
            ArryLogBtn(ch).Text = LOG_BTN_START
        Else
            ArryLogBtn(ch).Text = LOG_BTN_STOP
        End If
        ArryTimerSel(ch).Enabled = State
        ArryDividerSel(ch).Enabled = State
        ArryEdgeUp(ch).Enabled = State
        ArryEdgeDown(ch).Enabled = State
    End Sub

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Dim retcode As Short

        'デバイスオープン
        Try
            retcode = Tusbs03cn4_Device_Open(DevId)
            If retcode <> 0 Then
                MessageBox.Show(Tusbs03cn4_GetErrMessage(retcode))
                Me.Close()
            Else
                SettingInit() '初期設定
                EnableDisableControl(0, True)
                EnableDisableControl(1, True)
                EnableDisableControl(2, True)
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message)
            Me.Close()
        End Try
    End Sub

    Private Sub Form1_FormClosed(sender As System.Object, e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        Dim ch As Byte

        For ch = 0 To 2
            If ArryLogBtn(ch).Text = LOG_BTN_STOP Then
                LogStop(ch)
            End If
        Next
        Tusbs03cn4_Device_Close(DevId)
    End Sub

    Private Sub LogStart(ch As Byte)
        Dim retcode As Short
        Dim EdgeSel As Byte
        ArryListCnt(ch).Items.Clear()
        If ArryEdgeUp(ch).Checked Then
            EdgeSel = 0
        Else
            EdgeSel = 1
        End If
        retcode = Tusbs03cn4_Counter_Start(DevId, ch, EdgeSel, ArryDividerSel(ch).SelectedIndex, ArryTimerSel(ch).SelectedIndex) 'ログカウント開始
        If retcode <> 0 Then
            MessageBox.Show(Tusbs03cn4_GetErrMessage(retcode))
            Return
        End If

        PreCount(ch) = 0 '差分カウント値算出のための前回値リセット
        ArryMeasTimer(ch).Enabled = True '測定タイマー開始

        '各コントロールの状態変更
        EnableDisableControl(ch, False)
        ArryEtcMessage(ch).Text = "ログ中"
        ArryLblFifolen(ch).BackColor = System.Drawing.Color.Transparent
    End Sub

    Private Sub LogStop(ch As Byte)
        Dim retcode As Short
        ArryMeasTimer(ch).Enabled = False '測定タイマー停止
        retcode = Tusbs03cn4_Counter_Stop(DevId, ch) 'カウンタ停止
        If retcode <> 0 Then
            MessageBox.Show(Tusbs03cn4_GetErrMessage(retcode))
            Return
        End If

        '各コントロールの状態変更
        EnableDisableControl(ch, True)
        ArryEtcMessage(ch).Text = "ログ終了"
    End Sub

    Private Sub LogBtn_Click(sender As System.Object, e As System.EventArgs) Handles LogBtn1.Click
        Dim tmpControl As Button = TryCast(sender, Button)
        Dim ch As Byte = CByte(tmpControl.Tag)

        If ArryLogBtn(ch).Text = LOG_BTN_START Then 'ログ開始の場合
            LogStart(ch)
        Else
            LogStop(ch)
        End If
    End Sub

    Private Sub MeasTimer_Tick(sender As System.Object, e As System.EventArgs) Handles MeasTimer1.Tick, MeasTimer3.Tick, MeasTimer2.Tick
        Dim retcode As Short
        Dim tmpControl As Timer = TryCast(sender, Timer)
        Dim ch As Byte = CByte(tmpControl.Tag)
        Dim FifoCnt As Short
        Dim CntL As Short
        Dim FifoH(511) As Integer 'ログデータ上位
        Dim FifoL(511) As Integer 'ログデータ下位
        Dim tmpN As Decimal
        Dim tmpStr As String

        retcode = Tusbs03cn4_Fifo_Cnt(DevId, ch, FifoCnt) '測定済みログデータ数取得
        If retcode <> 0 Then
            ArryMeasTimer(ch).Enabled = False
            MessageBox.Show(Tusbs03cn4_GetErrMessage(retcode))
            Return
        End If
        If FifoCnt >= 512 Then 'データバッファがいっぱいになっていたら(オーバーフロー)
            ArryLblFifolen(ch).BackColor = System.Drawing.Color.Salmon
            ArryEtcMessage(ch).Text = "FIFOオーバーフロー"
        End If

        ArryLblFifolen(ch).Text = CType(FifoCnt / 5.12, Short).ToString() + "%"

        If FifoCnt <> 0 Then '1つ以上のログデータがあれば
            retcode = Tusbs03cn4_Fifo_Read(DevId, ch, FifoCnt, FifoH, FifoL) 'ログデータ読み込み
            If retcode <> 0 Then
                ArryMeasTimer(ch).Enabled = False
                MessageBox.Show(Tusbs03cn4_GetErrMessage(retcode))
                Return
            End If
            tmpStr = ""
            For CntL = 0 To FifoCnt - 1
                tmpN = CType(FifoL(CntL), Decimal) + CType(FifoH(CntL), Decimal) * &H10000
                'カウント差分値の算出
                If tmpN < PreCount(ch) Then 'カウンタがオーバーフローしたか
                    tmpStr = (4294967296D + tmpN - PreCount(ch)).ToString()
                Else
                    tmpStr = (tmpN - PreCount(ch)).ToString()
                End If
                '前回カウント値の更新
                PreCount(ch) = tmpN

                'ログ表示リストコントロールに値を追加
                ArryListCnt(ch).Items.Add("[" + (ArryListCnt(ch).Items.Count).ToString("00000") + "]   " + tmpStr) 'FIFO内個数表示板
                If ArryListCnt(ch).Items.Count >= 32767 Then
                    LogStop(ch) '停止
                    ArryEtcMessage(ch).Text = "取込数制限で停止"
                    ArryListCnt(ch).TopIndex = 32766
                    Return
                End If
            Next

            'リストコントロール表示調整
            If ArryListCnt(ch).Items.Count <> 0 Then
                ArryListCnt(ch).TopIndex = ArryListCnt(ch).Items.Count - 1
            End If
        End If

    End Sub
End Class
