﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace S03CN4Sample
{
    public partial class Form1 : Form
    {
        const short DevId = 0; //デバイスIDは0固定
        const string LOG_BTN_START = "ログ開始";//ログボタンの文字　停止中(開始可能状態)
        const string LOG_BTN_STOP = "ログ停止";//ログボタンの文字　動作中(停止可能状態)
        private Decimal[] PreCount = new decimal[3];//ログ動作時の前回カウント値

        //コントロールの配列
        //この配列を通してコントロールを使用します。
        private  System.Windows.Forms.ComboBox[] ArryTimerSel;
        private  System.Windows.Forms.ComboBox[] ArryDividerSel;
        private  System.Windows.Forms.RadioButton[] ArryEdgeUp;
        private  System.Windows.Forms.RadioButton[] ArryEdgeDown;
        private  System.Windows.Forms.Label[] ArryLblFifolen;
        private  System.Windows.Forms.Label[] ArryEtcMessage;
        private  System.Windows.Forms.Button[] ArryLogBtn;
        private  System.Windows.Forms.ListBox[] ArryListCnt;
        private  System.Windows.Forms.Timer[] ArryMeasTimer;

        public Form1()
        {
            InitializeComponent();
        }

        private void SettingInit()
        {
            int ch;

            //コントロールの配列に画面のコントロールを設定します
            ArryTimerSel = new System.Windows.Forms.ComboBox[] { TimerSel1, TimerSel2, TimerSel3 };
            ArryDividerSel = new System.Windows.Forms.ComboBox[] {DividerSel1, DividerSel2, DividerSel3};
            ArryEdgeUp = new System.Windows.Forms.RadioButton[] {EdgeUp1, EdgeUp2, EdgeUp3};
            ArryEdgeDown = new System.Windows.Forms.RadioButton[] {EdgeDown1, EdgeDown2, EdgeDown3};
            ArryLblFifolen = new System.Windows.Forms.Label[] {LblFifolen1, LblFifolen2, LblFifolen3};
            ArryEtcMessage = new System.Windows.Forms.Label[] {EtcMessage1, EtcMessage2, EtcMessage3};
            ArryLogBtn = new System.Windows.Forms.Button[] {LogBtn1, LogBtn2, LogBtn3};
            ArryListCnt = new System.Windows.Forms.ListBox[] {ListCnt1, ListCnt2, ListCnt3};
            ArryMeasTimer = new System.Windows.Forms.Timer[] {MeasTimer1, MeasTimer2, MeasTimer3};

            for (ch = 0; ch < 3; ch++)
            {
                //各コントロールのTagにchを設定して後で操作に使用します
                ArryTimerSel[ch].Tag = (byte)ch;
                ArryDividerSel[ch].Tag = (byte)ch;
                ArryEdgeUp[ch].Tag = (byte)ch;
                ArryEdgeDown[ch].Tag = (byte)ch;
                ArryLblFifolen[ch].Tag = (byte)ch;
                ArryEtcMessage[ch].Tag = (byte)ch;
                ArryLogBtn[ch].Tag = (byte)ch;
                ArryListCnt[ch].Tag = (byte)ch;
                ArryMeasTimer[ch].Tag = (byte)ch;

                ArryEdgeUp[ch].Checked = true;
                ArryTimerSel[ch].SelectedIndex = 0;
                ArryDividerSel[ch].SelectedIndex = 0;
                ArryListCnt[ch].Items.Clear();

                ArryLblFifolen[ch].BackColor = System.Drawing.Color.Transparent;
            }
        }

        private void EnableDisableControl(byte ch, Boolean State)
        {
            if( State )
                ArryLogBtn[ch].Text = LOG_BTN_START;
            else
                ArryLogBtn[ch].Text = LOG_BTN_STOP;
            ArryTimerSel[ch].Enabled = State;
            ArryDividerSel[ch].Enabled = State;
            ArryEdgeUp[ch].Enabled = State;
            ArryEdgeDown[ch].Enabled = State;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            short retcode;

            //デバイスオープン
            try
            {
                if ((retcode = Tusbs03cn4.Tusbs03cn4_Device_Open(DevId)) != 0)
                {
                    MessageBox.Show(Tusbs03cn4.GetErrMessage(retcode));
                    this.Close();
                }
                else
                {
                    SettingInit();//初期設定
                    EnableDisableControl(0, true);
                    EnableDisableControl(1, true);
                    EnableDisableControl(2, true);
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
                this.Close();
            }
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            byte ch;

            for (ch = 0; ch < 3; ch++)
            {
                if (ArryLogBtn[ch].Text == LOG_BTN_STOP)
                {
                    LogStop(ch);
                }
            }

            Tusbs03cn4.Tusbs03cn4_Device_Close(DevId);
        }

        private void LogStart(byte ch)
        {
            short retcode;
            byte EdgeSel;

            ArryListCnt[ch].Items.Clear();
            if (ArryEdgeUp[ch].Checked)
                EdgeSel = 0;
            else
                EdgeSel = 1;
            if((retcode = Tusbs03cn4.Tusbs03cn4_Counter_Start(
                                            DevId,
                                            ch,
                                            EdgeSel,
                                            (byte) ArryDividerSel[ch].SelectedIndex,
                                            (byte) ArryTimerSel[ch].SelectedIndex)) != 0 )//ログカウント開始
            {
                MessageBox.Show(Tusbs03cn4.GetErrMessage(retcode));
                return;
            }

            PreCount[ch] = 0;//差分カウント値算出のための前回値リセット
            ArryMeasTimer[ch].Enabled = true;//測定タイマー開始

            //各コントロールの状態変更
            EnableDisableControl(ch, false);
            ArryEtcMessage[ch].Text = "ログ中";
            ArryLblFifolen[ch].BackColor = System.Drawing.Color.Transparent;
        }

        private void LogStop(byte ch)
        {
            short retcode;

            ArryMeasTimer[ch].Enabled = false;//測定タイマー停止
            if ((retcode = Tusbs03cn4.Tusbs03cn4_Counter_Stop(DevId, ch)) != 0)//カウンタ停止
            {
                MessageBox.Show(Tusbs03cn4.GetErrMessage(retcode));
                return;
            }

            //各コントロールの状態変更
            EnableDisableControl(ch, true);
            ArryEtcMessage[ch].Text = "ログ終了";
        }

        private void LogBtn_Click(object sender, EventArgs e)
        {
            Button tmpControl = (Button)sender;
            byte ch = (byte)tmpControl.Tag;

            if (ArryLogBtn[ch].Text == LOG_BTN_START)
                LogStart(ch);
            else
                LogStop(ch);
        }

        private void MeasTimer_Tick(object sender, EventArgs e)
        {
            short retcode;
            Timer tmpControl = (Timer)sender;
            byte ch = (byte)tmpControl.Tag;
            short FifoCnt;
            short CntL;
            int[] FifoH = new int[512];//ログデータ上位
            int[] FifoL = new int[512];//ログデータ下位
            Decimal tmpN;
            string tmpStr;

            if ((retcode = Tusbs03cn4.Tusbs03cn4_Fifo_Cnt(DevId, ch,out FifoCnt)) != 0)//測定済みログデータ数取得
            {
                ArryMeasTimer[ch].Enabled = false;
                MessageBox.Show(Tusbs03cn4.GetErrMessage(retcode));
                return;
            }
            if (FifoCnt >= 512)//データバッファがいっぱいになっていたら(オーバーフロー)
            {
                ArryLblFifolen[ch].BackColor = System.Drawing.Color.Salmon;
                ArryEtcMessage[ch].Text = "FIFOオーバーフロー";
            }

            ArryLblFifolen[ch].Text = ((short)(FifoCnt / 5.12)).ToString() + "%";

            if (FifoCnt != 0)//1つ以上のログデータがあれば
            {
                if ((retcode = Tusbs03cn4.Tusbs03cn4_Fifo_Read(DevId, ch, ref FifoCnt,  FifoH,  FifoL)) != 0)//ログデータ読み込み
                {
                    ArryMeasTimer[ch].Enabled = false;
                    MessageBox.Show(Tusbs03cn4.GetErrMessage(retcode));
                    return;
                }
                tmpStr = "";
                for (CntL = 0; CntL < FifoCnt; CntL++)
                {
                    tmpN = (Decimal)FifoL[CntL] + (Decimal)FifoH[CntL] * 0x10000;
                    //カウント差分値の算出
                    if (tmpN < PreCount[ch])//カウンタがオーバーフローしたか
                        tmpStr = (4294967296M + tmpN - PreCount[ch]).ToString();
                    else
                        tmpStr = (tmpN - PreCount[ch]).ToString();

                    //前回カウント値の更新
                    PreCount[ch] = tmpN;

                    //ログ表示リストコントロールに値を追加
                    ArryListCnt[ch].Items.Add("[" + (ArryListCnt[ch].Items.Count).ToString("00000") + "]   " + tmpStr);//FIFO内個数表示板
                    if (ArryListCnt[ch].Items.Count >= 32767)
                    {
                        LogStop(ch);//停止
                        ArryEtcMessage[ch].Text = "取込数制限で停止";
                        ArryListCnt[ch].TopIndex = 32766;
                        return;
                    }
                }

                //テストコントロール表示調整
                if (ArryListCnt[ch].Items.Count != 0)
                    ArryListCnt[ch].TopIndex = ArryListCnt[ch].Items.Count - 1;
            }
        }
    }
}
